## hime 0.9.10+git20150916+dfsg1

=== Makefile ===

include ../config.mak

CFLAGS= -DUNIX=1 $(WALL) $(OPTFLAGS) $(GTKINC) -I./IMdkit/include -I./im-client \
        -DHIME_TABLE_DIR=\"$(HIME_TABLE_DIR)\" \
        -DHIME_OGG_DIR=\"$(HIME_OGG_DIR)\" \
        -DDOC_DIR=\"$(DOC_DIR)\" \
        -DHIME_DEFAULT_ICON_DIR=\"$(HIME_DEFAULT_ICON_DIR)\" \
        -DHIME_SCRIPT_DIR=\"$(HIME_SCRIPT_DIR)\" -DHIME_BIN_DIR=\"$(HIME_BIN_DIR)\" \
        -DSYS_ICON_DIR=\"$(SYS_ICON_DIR)\" -DFREEBSD=$(FREEBSD) -DMAC_OS=$(MAC_OS) \
        -DHIME_VERSION=\"$(shell head -n 1 ../ChangeLog)\" \
        -DG_DISABLE_SINGLE_INCLUDES -DG_DISABLE_DEPRECATED \
        -DGDK_DISABLE_SINGLE_INCLUDES -DGDK_DISABLE_DEPRECATED \
        -DGTK_DISABLE_SINGLE_INCLUDES -DGTK_DISABLE_DEPRECATED -DGSEAL_ENABLE

OBJ_IMSRV = im-addr.o im-dispatch.o im-srv.o hime-crypt.o

hime_pho_o  = win-pho.o pho.o pho-util.o pho-sym.o table-update.o pho-dbg.o
hime_gtab_o = gtab.o win-gtab.o gtab-util.o gtab-list.o gtab-buf.o


OBJS      = hime.o eve.o util.o hime-conf.o hime-settings.o locale.o \
	hime-icon.o about.o \
	hime-exec-script.o pho-play.o cache.o gtk_bug_fix.o \
	phrase-save-menu.o \
	$(hime_pho_o) $(hime_gtab_o) \
	hime-common.o phrase.o t2s-lookup.o gtab-use-count.o \
	win-save-phrase.o unix-exec.o pho-kbm-name.o statistic.o tsin-scan.o \
	hime-module.o lang.o \
	hime-module-cb.o gtab-init.o fullchar.o gtab-tsin-fname.o \
	win-message.o win-sym.o win-inmd-switch.o pinyin.o \
	win-pho-near.o win-kbm.o pho2pinyin.o

OBJS_TSLEARN = hime-tslearn.o util.o hime-conf.o pho-util.o tsin-util.o \
	pho-sym.o table-update.o locale.o \
	hime-settings.o hime-common.o hime-icon.o pho-dbg.o \
	pho2pinyin.o pinyin.o lang.o gtab-list.o gtab-init.o fullchar.o \
	gtab-tsin-fname.o unix-exec.o gtab-util.o

OBJS_TS_EDIT = hime-ts-edit.o util.o hime-conf.o pho-util.o tsin-util.o \
	pho-sym.o table-update.o locale.o \
	hime-settings.o hime-common.o hime-icon.o pho-dbg.o \
	pho2pinyin.o pinyin.o lang.o gtab-list.o gtab-init.o fullchar.o \
	gtab-tsin-fname.o unix-exec.o gtab-util.o

OBJS_JUYIN_LEARN = hime-juyin-learn.o locale.o util.o pho-util.o pho-sym.o \
	pho2pinyin.o hime-settings.o hime-conf.o table-update.o pinyin.o \
	hime-icon.o pho-dbg.o

OBJS_hime-sim2trad = hime-sim2trad.o util.o locale.o hime-conf.o hime-icon.o t2s-lookup.o hime-settings.o

OBJS_hime-phod2a = hime-phod2a.o pho-util.o hime-conf.o pho-sym.o table-update.o \
	pho-dbg.o locale.o hime-settings.o util.o

OBJS_hime-tsa2d32 = hime-tsa2d32.o util.o pho-sym.o hime-conf.o \
	locale.o pho-lookup.o pinyin.o pho2pinyin.o pho-dbg.o

OBJS_hime-phoa2d = hime-phoa2d.o pho-sym.o hime-conf.o locale.o \
	pho-lookup.o util.o pho-dbg.o

OBJS_kbmcv = kbmcv.o pho-sym.o util.o locale.o

OBJS_hime-tsd2a32 = hime-tsd2a32.o pho-sym.o pho-dbg.o locale.o util.o \
	gtab-dbg.o pho2pinyin.o hime-conf.o pinyin.o

OBJS_cin2gtab     = hime-cin2gtab.o gtab-util.o util.o locale.o
OBJS_gtab2cin     = hime-gtab2cin.o gtab-util.o util.o locale.o
OBJS_gtab_merge   = hime-gtab-merge.o gtab-util.o util.o locale.o
OBJS_hime_setup   = hime-setup.o hime-conf.o util.o hime-settings.o \
	hime-setup-list.o locale.o hime-setup-pho.o about.o \
	lang.o hime-icon.o hime-setup-gtab.o hime-setup-appearance.o gtab-list.o hime-exec-script.o \
	pho-kbm-name.o hime-module-cb.o

OBJS_hime_gb_toggle  = hime-gb-toggle.o  hime-conf.o util.o
OBJS_hime_message    = hime-message.o    hime-conf.o util.o

OBJS_pin_juyin       = pin-juyin.o util.o pho-lookup.o locale.o pho-sym.o

OBJS_tsin2gtab_phrase = hime-tsin2gtab-phrase.o hime-conf.o util.o locale.o \
	pho-dbg.o pho-sym.o gtab-dbg.o lang.o


#WALL=-Wall

ifeq ($(USE_XIM),Y)
IMdkitLIB   = IMdkit/lib/libXimd.a
CFLAGS     += -DUSE_XIM=1
OBJS       += IC.o
endif

ifeq ($(USE_TRAY),Y)
CFLAGS     += -DTRAY_ENABLED=1
OBJS       += tray.o tray-double.o
ifeq ($(GTK),gtk+-2.0)
OBJS       += gdkpixbuf-drawable.o
endif
ifeq ($(USE_UNITY),Y)
CFLAGS     += -DTRAY_UNITY=1
OBJS       += tray-appindicator.o
endif
endif

ifeq ($(USE_I18N),Y)
CFLAGS     += -DHIME_i18n_message=1
endif

ifeq ($(USE_TSIN),Y)
hime_tsin_o = tsin.o tsin-util.o win0.o win1.o tsin-parse.o
CFLAGS     += -DUSE_TSIN=1
OBJS       += $(hime_tsin_o)
endif

# Temporary workaround to turn off Tsin, will be fixed later
ifeq ($(USE_TSIN),N)
OBJS       += tsin.o tsin-util.o win0.o win1.o tsin-parse.o
endif

ifeq ($(MAC_OS),1)
EXTRA_LDFLAGS=-bind_at_load 
endif

ifeq ($(GIT_HAVE),Y)
CFLAGS     += -DGIT_HASH=\"$(GIT_HASH)\" -DGIT_HAVE=1
endif

PROGS     = hime \
	hime-tsd2a32 hime-tsa2d32 hime-phoa2d hime-phod2a \
	hime-tslearn hime-setup hime-cin2gtab hime-gtab2cin \
	hime-juyin-learn hime-sim2trad hime-gb-toggle hime-message hime-gtab-merge \
	hime-tsin2gtab-phrase hime-ts-edit

PROGS_SYM = hime-trad2sim hime-exit hime-sim hime-trad hime-kbm-toggle

PROGS_CV  = kbmcv pin-juyin

.SUFFIXES:  .c .o .E .pico .cpp

.cpp.o:
	@echo "  $< -> $@"
	$(CCX) $(CPPFLAGS) $(CFLAGS) -c $<
.c.o:
	@echo "  $< -> $@"
	$(CC) $(CPPFLAGS) $(CFLAGS) -c $<
.c.pico:
	@echo "  $< -> $@"
	$(CC) $(CPPFLAGS) $(CFLAGS) -c -fpic -o $@ $<
.cpp.pico:
	@echo "  $< -> $@"
	$(CCX) $(CPPFLAGS) $(CFLAGS) -c -fpic -o $@ $<
.c.E:
	@echo "  $< -> $@"
	$(CC) $(CPPFLAGS) $(CFLAGS) -E -o $@ $<
.cpp.E:
	@echo "  $< -> $@"
	$(CCX) $(CPPFLAGS) $(CFLAGS) -E -o $@ $<


all: $(PROGS) $(PROGS_SYM) $(DATA) $(PROGS_CV)
	$(MAKE) -C modules
	if [ $(GTK_IM) = 'Y' ]; then $(MAKE) -C gtk-im; fi
	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C gtk3-im; fi
	if [ $(QT_IM) = 'Y' ]; then $(MAKE) -C qt-im; fi
	if [ $(QT4_IM) = 'Y' ]; then $(MAKE) -C qt4-im; fi
	if [ $(QT5_IM) = 'Y' ]; then $(MAKE) -C qt5-im; fi

$(IMdkitLIB):
	@echo "building $@ ..."
	$(MAKE) -C IMdkit/lib

im-client/libhime-im-client.so:
	@echo "building $@ ..."
	$(MAKE) -C im-client

hime: $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV)
	@echo "linking $@ ..."
ifeq ($(FREEBSD), 0)
	$(CCLD) $(EXTRA_LDFLAGS) $(gcc_ld_run_path) -o $@ $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV) -lXtst $(LDFLAGS) -L/usr/X11R6/$(LIB)
else
	$(CCLD) $(EXTRA_LDFLAGS) $(gcc_ld_run_path) -o $@ $(OBJS) $(IMdkitLIB) $(OBJ_IMSRV) -lXtst $(LDFLAGS) -L/usr/local/$(LIB)
endif
	@rm -f core.* vgcore.*

hime-tslearn: $(OBJS_TSLEARN) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

hime-ts-edit: $(OBJS_TS_EDIT) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

hime-juyin-learn: $(OBJS_JUYIN_LEARN)
	@echo "linking $@ ..."
	$(CCLD) -o $@ $^ $(LDFLAGS)
	@rm -f core.*

hime-sim2trad: $(OBJS_hime-sim2trad)
	@echo "linking $@ ..."
	$(CC) $(gcc_ld_run_path) -o $@ $^ $(LDFLAGS)
	@rm -f core.*

hime-trad2sim:  hime-sim2trad
	ln -sf hime-sim2trad $@

hime-setup: $(OBJS_hime_setup) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	@rm -f core.*
	$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

hime-phoa2d: $(OBJS_hime-phoa2d) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

hime-phod2a: $(OBJS_hime-phod2a)
	@echo "linking $@ ..."
	$(CCLD) -lX11 -o $@ $^ $(LDFLAGS)

hime-tsa2d32:  $(OBJS_hime-tsa2d32) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

#hime-tsd2a:
#	$(CCLD) -o $@ $(LDFLAGS)

hime-tsd2a32: $(OBJS_hime-tsd2a32)
	@echo "linking $@ ..."
	$(CCLD) -o $@ $^ $(LDFLAGS)


hime-cin2gtab: $(OBJS_cin2gtab)
	@echo "linking $@ ..."
	$(CCLD) -o $@ $^ $(LDFLAGS)
	@rm -f data/*.gtab

hime-gtab2cin: $(OBJS_gtab2cin)
	@echo "linking $@ ..."
	$(CCLD) -o $@ $^ $(LDFLAGS)

hime-gtab-merge: $(OBJS_gtab_merge)
	@echo "linking $@ ..."
	$(CCLD) -o $@ $^ $(LDFLAGS)

kbmcv: $(OBJS_kbmcv)
	@echo "linking $@ ..."
	$(CCLD) -o $@ $^ $(LDFLAGS)

hime-gb-toggle: $(OBJS_hime_gb_toggle) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

hime-kbm-toggle: hime-gb-toggle
	ln -sf hime-gb-toggle $@

hime-exit: hime-gb-toggle
	ln -sf hime-gb-toggle $@

hime-trad: hime-gb-toggle
	ln -sf hime-gb-toggle $@

hime-sim: hime-gb-toggle
	ln -sf hime-gb-toggle $@

hime-message: $(OBJS_hime_message) im-client/libhime-im-client.so
	@echo "linking $@ ..."
	$(CCLD) $(gcc_ld_run_path) -o $@ $^ -L./im-client -lhime-im-client $(LDFLAGS)

pin-juyin: $(OBJS_pin_juyin)
	@echo "linking $@ ..."
	$(CCLD) -o $@ $^ $(LDFLAGS)

hime-tsin2gtab-phrase: $(OBJS_tsin2gtab_phrase)
	@echo "linking $@ ..."
	$(CCLD) -o $@ $^ $(LDFLAGS)

install:
	install -d "$(bindir)"
	install $(PROGS) "$(bindir)"
	rm -f "$(bindir)/hime-trad2sim"; ln -sf hime-sim2trad "$(bindir)/hime-trad2sim"
	rm -f "$(bindir)/hime-exit"; ln -sf hime-gb-toggle "$(bindir)/hime-exit"
	rm -f "$(bindir)/hime-trad"; ln -sf hime-gb-toggle "$(bindir)/hime-trad"
	rm -f "$(bindir)/hime-sim"; ln -sf hime-gb-toggle "$(bindir)/hime-sim"
	rm -f "$(bindir)/hime-kbm-toggle"; ln -sf hime-gb-toggle "$(bindir)/hime-kbm-toggle"
	install -d "$(himelibdir)"
	install -d "$(includedir)"
	install -m 644 im-client/hime-im-client.h im-client/hime-im-client-attr.h "$(includedir)"
	$(MAKE) -C im-client install
	$(MAKE) -C modules install
	if [ $(GTK_IM) = 'Y' ]; then $(MAKE) -C gtk-im install; fi
	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C gtk3-im install; fi
	if [ $(QT_IM) = 'Y' ]; then $(MAKE) -C qt-im install; fi
	if [ $(QT4_IM) = 'Y' ]; then $(MAKE) -C qt4-im install; fi
	if [ $(QT5_IM) = 'Y' ]; then $(MAKE) -C qt5-im install; fi

clean:
	@echo "clean up"
	$(MAKE) -C IMdkit clean
	$(MAKE) -C im-client clean
	$(MAKE) -C modules clean
	if [ $(GTK_IM) = 'Y' ]; then $(MAKE) -C gtk-im clean; fi
	if [ $(GTK3_IM) = 'Y' ]; then $(MAKE) -C gtk3-im clean; fi
	$(MAKE) -C qt-im clean
	$(MAKE) -C qt4-im clean
	$(MAKE) -C qt5-im clean
	@rm -f *.o *.E *.db *.pico *.so tags $(PROGS) $(PROGS_CV) \
		$(DATA) .depend $(PROGS_SYM) hime.log hime-fedora.spec
	@find . '(' -name '.ted*' -o -name '*~' -o -name 'core.*' -o -name 'vgcore.*' ')' -exec rm {} \;

.depend:
	@echo "building $@ ..."
	$(CCX) $(CPPFLAGS) $(CFLAGS) -MM *.c > $@



include .depend

=== gtk-im/Makefile ===
include ../../config.mak

OBJS = imhime.o gtkimcontexthime.o
GTK2IM=gtk-2.0/immodules
GTKINC=`pkg-config --cflags gtk+-2.0`
LDFLAGS=`pkg-config --libs gtk+-2.0`
GTK_LIBDIR=`pkg-config --variable=libdir gtk+-2.0`
GTK_BINARY_VERSION=`pkg-config --variable=gtk_binary_version gtk+-2.0`
MODULEDIR=$(DESTDIR)/$(GTK_LIBDIR)/gtk-2.0/$(GTK_BINARY_VERSION)/immodules
IMMODULES=$(libdir)/$(GTK2IM)
IMMODULES_LOCAL=/usr/$(LIB)/$(GTK2IM)
IMMODULES_QUERY=`whereis gtk-query-immodules-2.0 | cut -d ' ' -f 2`


ifeq ($(MAC_OS),1)
EXTRA_INC=-I/sw/include
endif

.SUFFIXES:	.c .o .E
CFLAGS = $(OPTFLAGS) $(EXTRA_INC) $(GTKINC) -I../im-client -I.. -DUNIX=1 \
-I../IMdkit/include -DCLIENT_LIB=1 -DMAC_OS=$(MAC_OS) -DFREEBSD=$(FREEBSD)

.c.o:
	@echo "  $< -> $@"
	$(CC) -c -fPIC $(CPPFLAGS) $(CFLAGS) -o $@ $<

.c.E:
	@echo "  $< -> $@"
	$(CC) -E $(CPPFLAGS) $(CFLAGS) -o $@ $<

all:	im-hime.so

im-hime.so:     $(OBJS) ../im-client/libhime-im-client.so
	@echo "linking $@ ..."
	$(CC) $(gcc_ld_run_path) $(SO_FLAGS) $(OBJS) -L../im-client -lhime-im-client -o $@ $(LDFLAGS)
	@rm -f core.*

clean:
	@echo "clean up"
	@rm -f *.o *.so *~ core.* .depend *.E

install:
	if [ "$(prefix)" = "/usr/local" -o "$(prefix)" = "/usr" ]; then \
		install -d $(MODULEDIR); \
		install -m 755 im-hime.so $(MODULEDIR); \
		if [ "$(prefix)" = "/usr/local" ]; then \
			if [ -d $(DESTDIR)/etc/gtk-2.0 ]; then \
				cd $(DESTDIR)/etc/gtk-2.0; $(IMMODULES_QUERY) > gtk.immodules; \
			fi \
		fi \
	else \
		install -d $(IMMODULES); \
		install -m 755 im-hime.so $(IMMODULES); \
	fi

.depend:
	@echo "building $@ ..."
	$(CC) $(CPPFLAGS) $(CFLAGS) -MM *.c > $@

include .depend

=== gtk3-im/Makefile ===
include ../../config.mak

OBJS = imhime.o gtkimcontexthime.o
GTK3IM=gtk-3.0/immodules
GTKINC=`pkg-config --cflags gtk+-3.0`
LDFLAGS+=`pkg-config --libs gtk+-3.0`
GTK3_LIBDIR=`pkg-config --variable=libdir gtk+-3.0`
GTK3_BINARY_VERSION=`pkg-config --variable=gtk_binary_version gtk+-3.0`
MODULEDIR=$(DESTDIR)/$(GTK3_LIBDIR)/gtk-3.0/$(GTK3_BINARY_VERSION)/immodules
IMMODULES=$(libdir)/$(GTK3IM)
IMMODULES_LOCAL=/usr/$(LIB)/$(GTK3IM)
IMMODULES_QUERY=$(shell whereis gtk-query-immodules-3.0 | awk -F ' = ' '{print $2}')
IMMODULES_CACHE=$(DESTDIR)/$(GTK3_LIBDIR)/gtk-3.0/$(GTK3_BINARY_VERSION)/immodules.cache

ifeq ($(MAC_OS),1)
EXTRA_INC=-I/sw/include
endif

.SUFFIXES:	.c .o .E
CFLAGS += $(OPTFLAGS) $(EXTRA_INC) $(GTKINC) -I../im-client -I.. -DUNIX=1 \
-I../IMdkit/include -DCLIENT_LIB=1 -DMAC_OS=$(MAC_OS) -DFREEBSD=$(FREEBSD)

.c.o:
	@echo "  $< -> $@"
	$(CC) -c -fPIC $(CPPFLAGS) $(CFLAGS) -o $@ $<

.c.E:
	@echo "  $< -> $@"
	$(CC) -E $(CPPFLAGS) $(CFLAGS) -o $@ $<

all:	im-hime.so

im-hime.so:     $(OBJS) ../im-client/libhime-im-client.so
	@echo "linking $@ ..."
	$(CC) $(gcc_ld_run_path) $(SO_FLAGS) $(OBJS) -L../im-client -lhime-im-client -o $@ $(LDFLAGS)
	@rm -f core.*

clean:
	@echo "clean up"
	@rm -f *.o *.so *~ core.* .depend *.E

install:
	if [ "$(prefix)" = "/usr/local" -o "$(prefix)" = "/usr" ]; then \
		install -d $(MODULEDIR); \
		install -m 755 im-hime.so $(MODULEDIR); \
		if [ "$(prefix)" = "/usr/local" ]; then \
			if [ -f "$(IMMODULES_QUERY)" -a -x "$(IMMODULES_QUERY)" ]; then \
				GTK_IM_MODULE_FILE=$(IMMODULES_CACHE) $(IMMODULES_QUERY) --update-cache; \
			fi \
		fi \
	else \
		install -d $(IMMODULES); \
		install -m 755 im-hime.so $(IMMODULES); \
	fi

.depend:
	@echo "building $@ ..."
	$(CC) $(CPPFLAGS) $(CFLAGS) -MM *.c > $@

include .depend

=== im-client/Makefile ===
include ../../config.mak

SOFILE=libhime-im-client.so
SOFILEVER=libhime-im-client.so.1.2.4

.SUFFIXES:      .c .o .E .cpp
WALL=-Wall
CFLAGS+= -DUNIX=1 $(WALL) $(OPTFLAGS) -I. -I.. -I../IMdkit/include $(GTKINC) \
        -DCLIENT_LIB=1 -DHIME_BIN_DIR=\"$(HIME_BIN_DIR)\" -DUNIX=1 \
        -DHIME_TABLE_DIR=\"$(HIME_TABLE_DIR)\" \
        -DFREEBSD=$(FREEBSD) -fPIC
OBJS = hime-im-client.o hime-send.o im-addr.o hime-conf.o util.o hime-crypt-fpic.o

.cpp.E:
	@echo "  $< -> $@"
	$(CC) $(CPPFLAGS) $(CFLAGS) -E -o $@ $<

.c.o:
	@echo "  $< -> $@"
	$(CC) -c $(CPPFLAGS) $(CFLAGS) $<

.cpp.o:
	@echo "  $< -> $@"
	$(CC) -x c -c $(CPPFLAGS) $(CFLAGS) $<

$(SOFILEVER):   $(OBJS)
	@echo "linking $@ ..."
# TODO: Drop g_get_tmp_dir() and -lglib-2.0
ifeq ($(FREEBSD), 0)
	$(CC) $(SO_FLAGS) -Wl,-soname,libhime-im-client.so.1 $(OBJS) -lX11 -lglib-2.0 -o $@ -L/usr/X11R6/lib
else
	$(CC) $(SO_FLAGS) -Wl,-soname,libhime-im-client.so.1 $(OBJS) -lX11 -lglib-2.0 -o $@ -L/usr/local/lib
endif
	ln -sf $(SOFILEVER) $(SOFILE)
	ln -sf $(SOFILEVER) $(SOFILE).1
	if [ $(GTK_IM) = 'Y' ]; then $(MAKE) -C ../gtk-im; fi

LOCALLIB=/usr/local/$(LIB)

install:
	install -d "$(himelibdir)"
	install -m 755 $(SOFILEVER) "$(himelibdir)"
	cd "$(himelibdir)"; rm -f $(SOFILE); ln -s $(SOFILEVER) $(SOFILE); \
	ln -sf $(SOFILEVER) $(SOFILE).1

hime-conf.o: ../hime-conf.c
	@echo "  $^ -> $@"
	$(CCX) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

util.o: ../util.c
	@echo "  $^ -> $@"
	$(CCX) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

im-addr.o: ../im-addr.c
	@echo "  $^ -> $@"
	$(CCX) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

hime-crypt-fpic.o: ../hime-crypt.c
	@echo "  $^ -> $@"
	$(CCX) -c $(CPPFLAGS) $(CFLAGS) -o $@ $<

clean:
	@echo "clean up"
	rm -f *.o *.so *.so.* *~ *.E *.db tags core.* .depend

.depend:
	@echo "building $@ ..."
	$(CCX) $(CPPFLAGS) $(CFLAGS) -MM *.c > $@

include .depend

=== qt-im/Makefile ===
include ../../config.mak
QT=qt3
QTIM=$(QT)/plugins/inputmethods
IMMODULES=$(libdir)/$(QTIM)
INCS=-I../im-client -I/usr/include `pkg-config --cflags qt-mt` -I/usr/include/Xft2/X11/Xft  -I/usr/include/fontconfig -I/usr/include/freetype2
CXXFLAGS+=$(OPTFLAGS) $(INCS) -Wall -D_REENTRANT -DUNIX=1 -fPIC  -DQT_THREAD_SUPPORT -DQT_PLUGIN -DQT_SHARED -DQT_NO_DEBUG
OBJS=qhimeinputcontextplugin.o qhimeinputcontextplugin_my.o qhimeinputcontext.o qhimeinputcontext_x11.o
.SUFFIXES:	.c .cpp .a .so .E .h
LDFLAGS+=$(LDFLAGS_ENV) -L../im-client -lhime-im-client -Wl,-rpath,$(himelibdir) `pkg-config qt-mt --libs`
all:	im-hime.so

.cpp.E:
	@echo "  $< -> $@"
	$(CXX) -E $(CFLAGS) $(INCS) $< > $@

.cpp.o:
	@echo "  $< -> $@"
	$(CXX) -c -o $@ $(CXXFLAGS) $<

.h.o:
	@echo "  $< -> $@"
	@$(QT3_MOC_PATH) $< -o $<_moc.cpp
	$(CXX) -c -pipe $(CXXFLAGS) $<_moc.cpp -o $@

im-hime.so: $(OBJS)
	@echo "linking $@ ..."
	$(CXX) $(gcc_ld_run_path) -fno-exceptions -shared -o $@ $(OBJS) $(LDFLAGS)
	@rm -f core.*

install:
	if [ $(prefix) = /usr/local ]; then \
		install -d $(QT_IM_DIR); \
		install -m 755 im-hime.so $(QT_IM_DIR); \
	else \
		install -d $(IMMODULES); \
                install -m 755 im-hime.so $(IMMODULES); \
	fi

clean:
	@echo "clean up"
	@rm -f $(OBJS) im-hime.so *~ core.* *moc*.cpp *.E

=== qt4-im/Makefile ===
include ../../config.mak

ifeq ($(FREEBSD), 0)
  INCS=-I../im-client -I/usr/include/X11 `pkg-config QtCore QtGui --cflags`
else
  INCS=-I../im-client -I/usr/local/include `pkg-config QtCore QtGui --cflags`
endif
CXXFLAGS+=$(OPTFLAGS) $(INCS) -Wall -D_REENTRANT -DUNIX=1 -fPIC  -DQT4 -DQT_SHARED \
-DQT_IMMODULE -DPIC
OBJS= moc_hime-qt.o hime-qt.o im-hime-qt.o hime-imcontext-qt.o
.SUFFIXES:	.c .cpp .a .so .E .h
LDFLAGS+=$(LDFLAGS_ENV) -L../im-client -lhime-im-client `pkg-config QtCore QtGui --libs`
all:    im-hime.so

.cpp.E:
	@echo "  $< -> $@"
	$(CXX) -E $(CFLAGS) $(INCS) $< > $@

.cpp.o:
	@echo "  $< -> $@"
	$(CXX) -c -o $@ $(CXXFLAGS) $<

moc_hime-qt.cpp:	hime-qt.h
	@echo "  $< -> $@"
	$(QT4_MOC_PATH) $< -o moc_hime-qt.cpp

im-hime.so: $(OBJS)
	@echo "linking $@ ..."
	@export LD_RUN_PATH=$(himelibdir) ;\
		$(CXX) $(gcc_ld_run_path) -fno-exceptions -shared -o $@ $(OBJS) $(LDFLAGS)
	@rm -f core.*

install:
	install -d "$(QT4_IM_DIR)"; \
	install -m 755 im-hime.so "$(QT4_IM_DIR)"

clean:
	@echo "clean up"
	@rm -f $(OBJS) im-hime.so *~ core.* *moc*.cpp *.E .depend

.depend:
	@echo "building $@ ..."
	$(CXX) $(CXXFLAGS) -MM *.cpp > $@

include .depend

=== qt5-im/Makefile ===
include ../../config.mak

ifeq ($(FREEBSD), 0)
  INCS=-I../im-client -I/usr/include/X11
else
  INCS=-I../im-client -I/usr/local/include
endif
INCS+=`pkg-config Qt5Core Qt5Gui Qt5PlatformSupport Qt5DBus --cflags`
INCS+=-I `pkg-config --variable=includedir Qt5Gui`/QtGui/`pkg-config --modversion Qt5Gui`/QtGui

CXXFLAGS=$(OPTFLAGS) $(INCS) -Wall -D_REENTRANT -DUNIX=1 -fPIC  -DQT5 -DQT_SHARED \
-DQT_IMMODULE -DPIC
OBJS= moc_hime-qt.o hime-qt.o hime-imcontext-qt.o moc_hime-imcontext-qt.o
.SUFFIXES:	.c .cpp .a .so .E .h
LDFLAGS=$(LDFLAGS_ENV) -L../im-client -lhime-im-client `pkg-config Qt5Core Qt5Gui Qt5PlatformSupport Qt5DBus --libs`


all:    im-hime.so

.cpp.E:
	@echo "  $< -> $@"
	@$(CXX) -E $(CFLAGS) $(INCS) $< > $@

.cpp.o:
	@echo "  $< -> $@"
	@$(CXX) -c -o $@ $(CXXFLAGS) $<

moc_hime-qt.cpp:	hime-qt.h
	@echo "  $< -> $@"
	@$(QT5_MOC_PATH) $(INCS) $< -o moc_hime-qt.cpp

moc_hime-imcontext-qt.cpp:	hime-imcontext-qt.h
	@echo "  $< -> $@"
	@$(QT5_MOC_PATH) $(INCS) $< -o moc_hime-imcontext-qt.cpp

im-hime.so: $(OBJS)
	@echo "linking $@ ..."
	@export LD_RUN_PATH=$(himelibdir) ;\
		$(CXX) $(gcc_ld_run_path) -fno-exceptions -shared -o $@ $(OBJS) $(LDFLAGS)
	@rm -f core.*

install:
	install -d "$(QT5_IM_DIR)"; \
	install -m 755 im-hime.so "$(QT5_IM_DIR)"

clean:
	@echo "clean up"
	@rm -f $(OBJS) im-hime.so *~ core.* *moc*.cpp *.E .depend

.depend:
	@echo "building $@ ..."
	@$(CXX) $(CXXFLAGS) -MM *.cpp > $@

include .depend

=== IMdkit/lib/Makefile ===
include ../../../config.mak

#CFLAGS =  -c -O2 -fno-strength-reduce -Dlinux -D__i386__ -D_POSIX_C_SOURCE=199309L -D_POSIX_SOURCE -D_XOPEN_SOURCE=500L -D_BSD_SOURCE -D_SVID_SOURCE   -DFUNCPROTO=15 -DNARROWPROTO   -DUNIXCONN -DTCPCONN -DXIM_t -DTRANS_SERVER
CFLAGS +=  -c $(OPTFLAGS) -fno-strength-reduce -DXIM_t -DTRANS_SERVER
ifeq ($(FREEBSD), 0)
  INC = -I../include -I/usr/X11R6/include
else
  INC = -I../include -I/usr/local/include/
endif

SRC = IMConn.c IMMethod.c FrameMgr.c i18nIMProto.c i18nAttr.c i18nMethod.c i18nUtil.c i18nPtHdr.c i18nIc.c i18nClbk.c i18nX.c

OBJ = $(SRC:.c=.o)

all: libXimd.a

libXimd.a: $(OBJ)
	@echo "archiving $@ ..."
	@ar cr $@ $(OBJ)
	@ranlib $@

.c.o:
	@echo "  $< -> $@"
	$(CC) $(CPPFLAGS) $(CFLAGS) $(INC) -c $<

clean:
	@echo "clean up"
	@rm -f libXimd.a *.o *.bak

=== dev-tools/qt3-test/Makefile ===
include ../../../config.mak

ECHO = $(shell whereis -b echo | awk '{print $$2}')

.PHONY: all
all: ed3.cpp ed3.h ed3.pro ed3a.cpp
	@ $(ECHO) -e "\x1b[1;33m** Compiling ed3...\x1b[0m"
	@ $(QT3_QMAKE_PATH) ed3.pro -o ed3.makefile && $(MAKE) -f ed3.makefile

.PHONY: clean
clean:
	-@ for FileName in ed3.makefile ed3a.o ed3.o ed3; \
	do \
		if [ -f "$$FileName" ]; then \
			$(ECHO) -e "\x1b[1;31m** "deleting $$FileName..."\x1b[0m"; \
			rm "$$FileName" ; \
		fi; \
	done

=== debian/changelog ===
hime (0.9.10+git20150916+dfsg1-2) unstable; urgency=medium

  * Update copyright to comply with machine-readable format.
  * Remove hime-dbg in favor of dbgsym.
  * Remove menu file in favor of desktop file.
  * Update Vcs-*.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 26 Dec 2015 01:13:18 +0800

hime (0.9.10+git20150916+dfsg1-1) unstable; urgency=medium

  * Imported Upstream version 0.9.10+git20150916+dfsg1 to fix FTBFS on big
    endianness platforms.
  * Remove upstream applied patch harden.patch.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 29 Sep 2015 13:53:42 +0800

hime (0.9.10+git20150821+dfsg-1) unstable; urgency=medium

  [ ChangZhuo Chen (陳昌倬) ]
  * Use git snapshot for Qt 5.
  * Support Multi-Arch:
    * Add --himelibdir.
    * Add libhime, hime-gtk2-immodule.
    * Add postinst, postrm scripts for GTK modules.
  * Update Vcs-Browser.
  * Remove hime-dev since libhime-im-client1 is not designed to be used
    outside HIME.

  [ Yao Wei (魏銘廷) ]
  * Make upstream tarball DFSG compatible.
  * Update homepage in debian/control.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Fri, 25 Sep 2015 22:38:49 +0800

hime (0.9.10-7) unstable; urgency=medium

  * Fix bashism in /bin/sh script. (Closes: #772236)

 -- Shih-Yuan Lee (FourDollars) <fourdollars@gmail.com>  Tue, 28 Apr 2015 21:18:41 +0800

hime (0.9.10-6) unstable; urgency=medium

  [ ChangZhuo Chen (陳昌倬) ]
  * Bump Standards-Version
  * Don't remove alternative when upgrade

  [ Yao Wei (魏銘廷) ]
  * Add libappindicator dependency (Closes: #776883)

 -- ChangZhuo Chen (陳昌倬) <czchen@gmail.com>  Mon, 27 Apr 2015 18:31:59 +0800

=== debian/control ===
Source: hime
Section: utils
Priority: extra
Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
Uploaders: Yao Wei (魏銘廷) <mwei@lxde.org>,
           ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
           Shih-Yuan Lee (FourDollars) <fourdollars@gmail.com>,
Standards-Version: 3.9.6
Homepage: http://hime-ime.github.io
Build-Depends: debhelper (>= 9.20151219),
               autotools-dev,
               dpkg-dev (>= 1.16.1~),
               libanthy-dev,
               libappindicator-dev,
               libchewing3-dev,
               libgtk2.0-dev (>= 2.20.0),
               libgtk-3-dev,
               libqt4-dev,
               libxtst-dev,
               qtbase5-private-dev,
               qtchooser,
Vcs-Git: git://anonscm.debian.org/pkg-ime/hime.git -b debian.sid
Vcs-Browser: http://anonscm.debian.org/cgit/pkg-ime/hime.git/?h=debian/sid

Package: hime
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${shlibs:Depends},
         hime-data,
         hime-tables,
         libhime,
Recommends: im-config | im-switch,
            hime-gtk2-immodule,
            hime-gtk3-immodule,
Suggests: hime-anthy,
          hime-chewing,
          hime-qt4-immodule,
          hime-qt5-immodule,
          gcin-voice,
Description: GTK+ based input method for Chinese users
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 To use HIME, the correspondence immodule packages also need to be installed.
 They are:
 .
  * hime-gtk2-immodule for GTK2
  * hime-gtk3-immodule for GTK3
  * hime-qt4-immodule for Qt4
  * hime-qt5-immodule for Qt5

Package: hime-data
Architecture: all
Depends: ${misc:Depends},
Description: icons, locales and scripts for HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package contains icons, locales, scripts and other architecture-
 independent things.

Package: hime-tables
Architecture: any
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: input method tables for HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package contains architecture-dependent input method tables.

Package: libhime
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
Description: library for HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package contains library for HIME.

Package: hime-gtk2-immodule
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         hime (>= ${source:Version}),
Breaks: hime (<< 0.9.10+git20150821+dfsg-1),
Replaces: hime (<< 0.9.10+git20150821+dfsg-1),
Description: GTK2 input method module with HIME as backend
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the GTK2 input method module (immodule) for HIME.

Package: hime-gtk3-immodule
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         hime (>= ${source:Version}),
Description: GTK3 input method module with HIME as backend
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the GTK3 input method module (immodule) for HIME.

Package: hime-qt4-immodule
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         hime (>= ${source:Version}),
Description: Qt4 input method module with HIME as backend
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the Qt4 input method module (immodule) for HIME.

Package: hime-qt5-immodule
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         hime (>= ${source:Version}),
Description: Qt5 input method module with HIME as backend
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the Qt5 input method module (immodule) for HIME.

Package: hime-anthy
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         hime (>= ${source:Version}),
         anthy,
Description: support library to use Anthy in HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the support library to use anthy in HIME.

Package: hime-chewing
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends},
         hime (>= ${source:Version}),
Description: support library to use Chewing in HIME
 HIME Input Method Editor is a input method platform, which is forked
 from the famous gcin input method.
 .
 This package is the support library to use chewing in HIME.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk

export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

CFLAGS+=$(CPPFLAGS)
CXXFLAGS+=$(CPPFLAGS)


GTK2_IMMODULES := $(shell pkg-config --variable=libdir gtk+-2.0)/libgtk2.0-0/gtk-query-immodules-2.0
GTK3_IMMODULES := $(shell pkg-config --variable=libdir gtk+-3.0)/libgtk-3-0/gtk-query-immodules-3.0

%:
	dh $@ 

override_dh_auto_clean:
	touch config.mak # dirty hack to make Makefile thinks config.mak exists
	make clean
	rm config.mak

override_dh_auto_configure:
	dh_auto_configure -- \
		--himelibdir=/usr/lib/$(DEB_HOST_MULTIARCH)/hime \
		--qt4-moc-path="qtchooser -run-tool=moc -qt=4" \
		--qt5-moc-path="qtchooser -run-tool=moc -qt=5" \
		$(NULL)

	sed 's,%%GTK_QUERY_IMMODULES%%,$(GTK2_IMMODULES),g' $(CURDIR)/debian/hime-gtk-immodule.postinst.in > $(CURDIR)/debian/hime-gtk2-immodule.postinst
	sed 's,%%GTK_QUERY_IMMODULES%%,$(GTK2_IMMODULES),g' $(CURDIR)/debian/hime-gtk-immodule.postrm.in > $(CURDIR)/debian/hime-gtk2-immodule.postrm
	sed 's,%%GTK_QUERY_IMMODULES%%,$(GTK3_IMMODULES),g' $(CURDIR)/debian/hime-gtk-immodule.postinst.in > $(CURDIR)/debian/hime-gtk3-immodule.postinst
	sed 's,%%GTK_QUERY_IMMODULES%%,$(GTK3_IMMODULES),g' $(CURDIR)/debian/hime-gtk-immodule.postrm.in > $(CURDIR)/debian/hime-gtk3-immodule.postrm
 
override_dh_auto_install:
	make install DESTDIR=$(CURDIR)/debian/tmp

	# workaround to move arch-dep tables to /usr/lib
	mv debian/tmp/usr/share/hime/table debian/tmp/usr/lib/$(DEB_HOST_MULTIARCH)/hime/table
	ln -s /usr/lib/$(DEB_HOST_MULTIARCH)/hime/table debian/tmp/usr/share/hime/table

override_dh_installchangelogs:
	dh_installchangelogs ChangeLog

override_dh_makeshlibs:
	dh_makeshlibs -n

override_dh_strip:
	dh_strip --dbg-package=hime-dbg

override_dh_strip:
	dh_strip --ddeb-migration='hime-dbg (<< 0.9.10+git20150916+dfsg1-2~)'

override_dh_install:
	dh_install \
		--exclude=usr/include/hime-im-client-attr.h \
		--exclude=usr/include/hime-im-client.h \
		--exclude=usr/share/doc/hime/ChangeLog \
		--fail-missing

=== debian/watch ===
version=3
https://github.com/hime-ime/hime/downloads /downloads/hime-ime/hime/hime-(.*).dfsg.orig.tar.xz

## hime 0.9.10+git20170427+dfsg1

=== Makefile ===
include ../config.mak

SRC_DIR       = ../src
IM_CLIENT_DIR = $(SRC_DIR)/im-client

.SUFFIXES:	.kbmsrc .kbm .cin .gtab
CFLAGS+= -DUNIX=1 $(WALL) $(OPTFLAGS) $(GTKINC) -I$(SRC_DIR)
export HIME_NO_RELOAD=

DATA=pho.tab2 tsin32.idx gtab.list \
     cj.gtab ar30.gtab ar30-big.gtab array40.gtab pinyin.gtab jyutping.gtab cj5.gtab \
     et.kbm et26.kbm zo.kbm pinyin.kbm dvorak.kbm mitac.kbm colemak.kbm \
     ibm.kbm tsin32 hsu.kbm pho-huge.tab2 simplex.gtab symbols.gtab russian.gtab \
     greek.gtab cj-punc.gtab latin-letters.gtab tsin-1.src pin-juyin.xlt \
     t2s.dat s2t.dat cj543.gtab s-tsin32 s-tsin32.idx s-pho.tab2 s-pho-huge.tab2 \
     pinyin-no-tone.kbm simplex-punc.gtab hangul.gtab vims.gtab

DATAKEEP = symbol-table phrase.table phrase-ctrl.table

PHO_A2D    = $(SRC_DIR)/hime-phoa2d
TS_A2D     = $(SRC_DIR)/hime-tsa2d32
CIN2GTAB   = $(SRC_DIR)/hime-cin2gtab
KBMCV      = $(SRC_DIR)/kbmcv
PIN_JUYIN  = $(SRC_DIR)/pin-juyin

ifeq ($(USE_TSIN),Y)
REMOVE_TSIN = keep_tsin
endif

ifeq ($(USE_TSIN),N)
REMOVE_TSIN = remove_tsin
endif

ifeq ($(INSTALL_DFSG_INCOMPATIBLE),Y)
DATA += dayi3.gtab
endif

all:	$(DATA)

$(PHO_A2D):
	$(MAKE) -C $(SRC_DIR) hime-phoa2d

$(TS_A2D):
	$(MAKE) -C $(SRC_DIR) hime-tsa2d32

$(CIN2GTAB):
	$(MAKE) -C $(SRC_DIR) hime-cin2gtab

$(KBMCV):
	$(MAKE) -C $(SRC_DIR) kbmcv

$(PIN_JUYIN):
	$(MAKE) -C $(SRC_DIR) pin-juyin

tsin32:	tsin.src  $(TS_A2D)
	export LD_LIBRARY_PATH=$(IM_CLIENT_DIR); $(TS_A2D) $<
tsin32.idx:	tsin32


s-tsin32:	s-tsin.src  $(TS_A2D)
	export LD_LIBRARY_PATH=$(IM_CLIENT_DIR); $(TS_A2D) $< $@
s-tsin32.idx:	s-tsin32


pho.tab2:	 pho.tab2.src $(PHO_A2D)
	export LD_LIBRARY_PATH=$(IM_CLIENT_DIR); $(PHO_A2D) $<

s-pho.tab2:	 s-pho.tab2.src $(PHO_A2D)
	export LD_LIBRARY_PATH=$(IM_CLIENT_DIR); $(PHO_A2D) $<

pho-huge.tab2:	 pho-huge.tab2.src $(PHO_A2D)
	export LD_LIBRARY_PATH=$(IM_CLIENT_DIR); $(PHO_A2D) $<

s-pho-huge.tab2:	 s-pho-huge.tab2.src $(PHO_A2D)
	export LD_LIBRARY_PATH=$(IM_CLIENT_DIR); $(PHO_A2D) $<

t2s.dat:	t2s-file t2s-file.table
	./t2s-file
s2t.dat:	t2s-file

pin-juyin.xlt: $(PIN_JUYIN) pin-juyin.src
	$(PIN_JUYIN)

extr1:	extr1.c
	@echo "building $@ ..."
	$(CC) $(CFLAGS) $< $(SRC_DIR)/util.o $(SRC_DIR)/locale.o -o $@ $(LDFLAGS)

t2s-file:	t2s-file.c
	@echo "building $@ ..."
	$(CC) $(CFLAGS) $< $(SRC_DIR)/util.o $(SRC_DIR)/locale.o -o $@ $(LDFLAGS)

tsin-1.src:	extr1
	./extr1 > $@

.cin.gtab: $(CIN2GTAB)
	$(CIN2GTAB) $<

.kbmsrc.kbm: $(KBMCV)
	$(KBMCV) $<

keep_tsin: gtab.list.in
	cp gtab.list.in gtab.list

remove_tsin: gtab.list.in
	grep -v TSIN gtab.list.in > gtab.list

gtab.list: $(REMOVE_TSIN)
	touch gtab.list

install:
	install -d "$(HIME_TABLE_DIR_i)"
	install -m 644 $(DATA) $(DATAKEEP) "$(HIME_TABLE_DIR_i)"
#	cd "$(HIME_TABLE_DIR_i)"; bzip2 -f *.gtab

clean:
	@echo "clean up"
	@rm -f *~ tags core.* $(DATA) *.gtab extr1 t2s-file tsin-1.src tsin-gtabidx* tsin-ch-idx gtab.list

=== freebsd/Makefile ===
# New ports collection makefile for:	zh-hime
# Date created:				2012/06/20
# Whom:					The HIME project
# Depends:				git gtk20 intltool libXtst gtk30 gmake ja-anthy
#					zh-libchewing qt4-moc qt4-corelib qt4-gui
#
# $FreeBSD$
#

PORTNAME=	hime
DATE!=		/bin/date "+%Y%m%d"
PORTVERSION=	0.9.10+git${DATE}
CATEGORIES=	chinese textproc
MASTER_SITES=	http://hime.luna.com.tw/

MAINTAINER=	The HIME project
COMMENT=	A GTK2+/GTK3+ based universal input method platform

LICENSE=	LGPL21

USE_GMAKE=	yes
HAS_CONFIGURE=	yes

USE_XORG=	xtst
USE_GNOME=	gtk20
USE_LDCONFIG=	yes
WITH_DEBUG=	yes
OPTIONS=	NLS		"Enable Native Language Support"	on \
		GTK3_IM_MODULE	"Build the GTK+3 im-module"		on \
		QT4_IM_MODULE	"Build the QT4 im-module"		on \
		ANTHY		"Support Anthy input method"		on \
		CHEWING		"Support Chewing input method"		on

TMP_PLIST_DIR=	build

do-fetch:

do-extract:
	@${RM} -rf ${WRKDIR}
	@${MKDIR} ${WRKDIR}
	(cd ${WRKDIR} && \
	 git clone --depth=1 git://github.com/hime-ime/hime.git && \
	 ${LN} -s ${PORTNAME} ${PORTNAME}-${PORTVERSION})

pre-patch:
	@${SED} -i -e 's/^\(	install -m 644 \*\.1 \$$(man1dir)\)$$/\1 \&\& find .\/ -name "*.1" -exec gzip $$(man1dir)\/{} \\;/g' ${WRKDIR}/${PORTNAME}/man/Makefile

.include <bsd.port.options.mk>

.if defined(WITH_GTK3_IM_MODULE)
BUILD_DEPENDS+=	${LOCALBASE}/libdata/pkgconfig/gtk+-3.0.pc:${PORTSDIR}/x11-toolkits/gtk30
GTK3_BINARY_VERSION!=	/usr/local/bin/pkg-config --variable=gtk_binary_version gtk+-3.0
.else
CONFIGURE_ARGS+=--disable-gtk3-im-module
.endif

.if defined(WITH_QT4_IM_MODULE)
BUILD_DEPENDS+=	/usr/local/libdata/pkgconfig/QtGui.pc:${PORTSDIR}/x11-toolkits/qt4-gui \
		/usr/local/libdata/pkgconfig/QtCore.pc:${PORTSDIR}/devel/qt4-corelib \
		/usr/local/bin/moc-qt4:${PORTSDIR}/devel/qt4-moc
QT_NONSTANDARD=	yes
.else
CONFIGURE_ARGS+=--disable-qt4-immodule
.endif

.if defined(WITH_ANTHY)
BUILD_DEPENDS+=	${LOCALBASE}/include/anthy/anthy.h:${PORTSDIR}/japanese/anthy
.else
CONFIGURE_ARGS+=--disable-anthy
.endif

.if defined(WITH_CHEWING)
BUILD_DEPENDS+=	zh-libchewing>=0.3.2:${PORTSDIR}/chinese/libchewing
.else
CONFIGURE_ARGS+=--disable-chewing
.endif

.if !defined(WITHOUT_NLS)
USE_GETTEXT=	yes
.else
CONFIGURE_ARGS+=--disable-nls
.endif

post-install:
	@${RM} -rf ${WRKDIR}/${TMP_PLIST_DIR}
	@${MKDIR} ${WRKDIR}/${TMP_PLIST_DIR}
	( cd ${WRKDIR}/${PORTNAME} && \
	  ${GMAKE} DESTDIR=${WRKDIR}/${TMP_PLIST_DIR} install && \
	  cd ${WRKDIR}/${TMP_PLIST_DIR}${PREFIX} && \
	  ${FIND} ./ -type f > ${TMPPLIST} && \
	  ${FIND} ./ -type l >> ${TMPPLIST} && \
	  mtree -U -f ${MTREE_FILE} && \
	  DIRLIST=`mtree -L -d -f ${MTREE_FILE} | ${SED} -e 's/ extra$$//g'` && \
	  for DIR in $$DIRLIST; do \
	  	case "$$DIR" in \
			lib/gtk-2.0|lib/gtk-3.0|share/locale/en_US|lib/qt4) ;; \
			*) ${FIND} $$DIR -type d | ${SORT} -r | ${SED} -e 's/^/@dirrm /g' >> ${TMPPLIST};; \
		esac ; \
	  done; \
	  echo '@exec gtk-query-immodules-2.0 > %D/etc/gtk-2.0/gtk.immodules || /usr/bin/true' >> ${TMPPLIST}; \
	  echo '@unexec gtk-query-immodules-2.0 > %D/etc/gtk-2.0/gtk.immodules || /usr/bin/true' >> ${TMPPLIST} )
.if defined(WITH_GTK3_IM_MODULE)
	  echo '@exec gtk-query-immodules-3.0 > %D/lib/gtk-3.0/${GTK3_BINARY_VERSION}/immodules.cache 2>/dev/null || /usr/bin/true' >> ${TMPPLIST};
	  echo '@unexec gtk-query-immodules-3.0 > %D/lib/gtk-3.0/${GTK3_BINARY_VERSION}/immodules.cache 2>/dev/null || /usr/bin/true' >> ${TMPPLIST};
.endif

.include <bsd.port.mk>

=== gtk-im/Makefile ===
--- 
+++ 
@@ -41,16 +41,16 @@
 
 install:
 	if [ "$(prefix)" = "/usr/local" -o "$(prefix)" = "/usr" ]; then \
-		install -d $(MODULEDIR); \
-		install -m 755 im-hime.so $(MODULEDIR); \
+		install -d "$(MODULEDIR)"; \
+		install -m 755 im-hime.so "$(MODULEDIR)"; \
 		if [ "$(prefix)" = "/usr/local" ]; then \
-			if [ -d $(DESTDIR)/etc/gtk-2.0 ]; then \
-				cd $(DESTDIR)/etc/gtk-2.0; $(IMMODULES_QUERY) > gtk.immodules; \
+			if [ -d "$(DESTDIR)/etc/gtk-2.0" ]; then \
+				cd "$(DESTDIR)/etc/gtk-2.0"; $(IMMODULES_QUERY) > gtk.immodules; \
 			fi \
 		fi \
 	else \
-		install -d $(IMMODULES); \
-		install -m 755 im-hime.so $(IMMODULES); \
+		install -d "$(IMMODULES)"; \
+		install -m 755 im-hime.so "$(IMMODULES)"; \
 	fi
 
 .depend:

=== gtk3-im/Makefile ===
--- 
+++ 
@@ -41,16 +41,16 @@
 
 install:
 	if [ "$(prefix)" = "/usr/local" -o "$(prefix)" = "/usr" ]; then \
-		install -d $(MODULEDIR); \
-		install -m 755 im-hime.so $(MODULEDIR); \
+		install -d "$(MODULEDIR)"; \
+		install -m 755 im-hime.so "$(MODULEDIR)"; \
 		if [ "$(prefix)" = "/usr/local" ]; then \
 			if [ -f "$(IMMODULES_QUERY)" -a -x "$(IMMODULES_QUERY)" ]; then \
 				GTK_IM_MODULE_FILE=$(IMMODULES_CACHE) $(IMMODULES_QUERY) --update-cache; \
 			fi \
 		fi \
 	else \
-		install -d $(IMMODULES); \
-		install -m 755 im-hime.so $(IMMODULES); \
+		install -d "$(IMMODULES)"; \
+		install -m 755 im-hime.so "$(IMMODULES)"; \
 	fi
 
 .depend:

=== modules/Makefile ===
include ../../config.mak
include ../suffixes-rule

CFLAGS+=-I.. -I../IMdkit/include
HIME_MODULE=intcode-module.so

ifeq ($(USE_ANTHY),Y)
HIME_MODULE+=anthy-module.so
CFLAGS += $(ANTHY_INC)
endif

ifeq ($(USE_CHEWING),Y)
HIME_MODULE+=chewing-module.so
CHEWING_DATADIR=$(shell pkg-config --variable=datadir chewing)
CFLAGS += -DCHEWING_DATADIR=\"$(CHEWING_DATADIR)\" $(shell pkg-config --cflags chewing)
endif

all:	$(HIME_MODULE)

anthy_module_so = anthy.pico
anthy-module.so: $(anthy_module_so)
	@echo "linking $@ ..."
	$(CCLD) $(SO_FLAGS) -o $@ $(anthy_module_so) $(LDFLAGS) $(ANTHY_INC)

intcode_module_so = intcode.pico win-int.pico
intcode-module.so: $(intcode_module_so)
	@echo "linking $@ ..."
	$(CCLD) $(SO_FLAGS) -o $@ $(intcode_module_so) $(LDFLAGS)

chewing_module_obj = chewing-conf.pico
chewing_module_so = chewing.pico hime-setup-chewing.pico
chewing-module.so: $(chewing_module_obj) $(chewing_module_so)
	@echo "linking $@ ..."
	$(CCLD) $(SO_FLAGS) -o $@ $(chewing_module_obj) $(chewing_module_so) $(LDFLAGS) $(shell pkg-config --cflags --libs chewing)

install:
	install $(HIME_MODULE) "$(himelibdir)"

clean:
	@echo "clean up"
	@rm -f *.pico *.so *.o

=== qt5-im/Makefile ===
--- 
+++ 
@@ -5,14 +5,19 @@
 else
   INCS=-I../im-client -I/usr/local/include
 endif
-INCS+=`pkg-config Qt5Core Qt5Gui Qt5PlatformSupport Qt5DBus --cflags`
-INCS+=-I `pkg-config --variable=includedir Qt5Gui`/QtGui/`pkg-config --modversion Qt5Gui`/QtGui
+
+QTINC=`pkg-config --variable=includedir Qt5Core`
+QTVER=`pkg-config --modversion Qt5Core`
+
+INCS+=`pkg-config Qt5Core Qt5Gui Qt5DBus --cflags`
+INCS+=-I$(QTINC)/QtGui/$(QTVER)
+INCS+=-I$(QTINC)/QtCore/$(QTVER)
 
 CXXFLAGS=$(OPTFLAGS) $(INCS) -Wall -D_REENTRANT -DUNIX=1 -fPIC  -DQT5 -DQT_SHARED \
 -DQT_IMMODULE -DPIC
 OBJS= moc_hime-qt.o hime-qt.o hime-imcontext-qt.o moc_hime-imcontext-qt.o
 .SUFFIXES:	.c .cpp .a .so .E .h
-LDFLAGS=$(LDFLAGS_ENV) -L../im-client -lhime-im-client `pkg-config Qt5Core Qt5Gui Qt5PlatformSupport Qt5DBus --libs`
+LDFLAGS=$(LDFLAGS_ENV) -L../im-client -lhime-im-client `pkg-config Qt5Core Qt5Gui Qt5DBus --libs`
 
 
 all:    im-hime.so

=== dev-tools/qt4-test/Makefile ===
include ../../../config.mak

ECHO = $(shell whereis -b echo | awk '{print $$2}')

.PHONY: all
all: ed4.cpp ed4.h ed4.pro ed4a.cpp
	@ $(ECHO) -e "\x1b[1;33m** Compiling ed4...\x1b[0m"
	@ $(QT4_QMAKE_PATH) ed4.pro -o ed4.makefile && $(MAKE) -f ed4.makefile

.PHONY: clean
clean:
	-@ for FileName in ed4.makefile ed4a.o ed4.o ed4; \
	do \
		if [ -f "$$FileName" ]; then \
			$(ECHO) -e "\x1b[1;31m** "deleting $$FileName..."\x1b[0m"; \
			rm "$$FileName" ; \
		fi; \
	done

=== debian/changelog ===
hime (0.9.10+git20170427+dfsg1-5build1) hirsute; urgency=medium

  * No-change rebuild against qtbase-abi-5-15-1.

 -- Dmitry Shachnev <mitya57@ubuntu.com>  Fri, 30 Oct 2020 14:02:21 +0300

hime (0.9.10+git20170427+dfsg1-5) unstable; urgency=medium

  * Replace dh_install with dh_missing.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 04 Oct 2020 19:07:48 +0800

hime (0.9.10+git20170427+dfsg1-4) unstable; urgency=medium

  [ Sudip Mukherjee ]
  * Fix ftbfs with GCC-10. (Closes: #957335, LP: #1897750)

  [ ChangZhuo Chen (陳昌倬) ]
  * Bump Standards-Version to 4.5.0.
    * Add Rules-Requires-Root: no.
  * Bump compat to 13.
  * Remove legacy debug package hime-dbg.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 04 Oct 2020 18:47:52 +0800

hime (0.9.10+git20170427+dfsg1-3) unstable; urgency=medium

  * Bump Standards-Version to 4.1.4.
  * Bump compat to 11.
  * Use new team mailing list (Closes: #899537).
  * Update Vcs-* fields to salsa.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Tue, 29 May 2018 17:45:03 +0800

hime (0.9.10+git20170427+dfsg1-2) unstable; urgency=medium

  * Bump Standards-Version to 4.1.0.
    * Change Priority to optional.
  * Remove hime-qt4-immodule (Closes: #874904).
  * Remove unnecessary Build-Depends autotools-dev.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 24 Sep 2017 18:04:12 +0800

hime (0.9.10+git20170427+dfsg1-1) unstable; urgency=medium

  * Update upstream git snapshot (Closes: #867575).
  * Bump Standards-Version to 4.0.0.
  * Bump compat to 10.
  * Update copyright.
    * Use https in Format.
    * Add Files-Excluded for DFSG.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sun, 09 Jul 2017 21:11:32 +0800

hime (0.9.10+git20150916+dfsg1-8) unstable; urgency=medium

  * Avoid using locale-dependent shell glob for reproducible build.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Sat, 02 Jul 2016 00:06:58 +0800

hime (0.9.10+git20150916+dfsg1-7) unstable; urgency=medium

  * Fix buggy version comparison in hime.postinst.
    Thanks to Chung-chieh Shan, Andreas Beckmann (Closes: #827927)

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Fri, 01 Jul 2016 11:08:50 +0800

hime (0.9.10+git20150916+dfsg1-6) unstable; urgency=medium

  * Remove randomness for reproducible build.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Thu, 30 Jun 2016 22:48:39 +0800

hime (0.9.10+git20150916+dfsg1-5) unstable; urgency=medium

  * Fix accessing uninitialized variable in maintainer script.
    Thanks: Chung-chieh Shan

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Fri, 24 Jun 2016 18:00:23 +0800

hime (0.9.10+git20150916+dfsg1-4) unstable; urgency=medium

  * Fix maintainer script error when install. (Closes: #827845)
  * Do not recommend im-switch.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Wed, 22 Jun 2016 08:53:28 +0800

hime (0.9.10+git20150916+dfsg1-3) unstable; urgency=medium

  * Fix FTBFS on Qt 5.6.1. (Closes: #827332)
  * Bump Standards-Version to 3.9.8.
  * Update Vcs-* fields.
  * Remove im-switch config.

 -- ChangZhuo Chen (陳昌倬) <czchen@debian.org>  Thu, 16 Jun 2016 12:08:09 +0800

=== debian/control ===
--- 
+++ 
@@ -1,26 +1,25 @@
 Source: hime
 Section: utils
-Priority: extra
-Maintainer: IME Packaging Team <pkg-ime-devel@lists.alioth.debian.org>
+Priority: optional
+Maintainer: Debian Input Method Team <debian-input-method@lists.debian.org>
 Uploaders: Yao Wei (魏銘廷) <mwei@lxde.org>,
            ChangZhuo Chen (陳昌倬) <czchen@debian.org>,
            Shih-Yuan Lee (FourDollars) <fourdollars@gmail.com>,
-Standards-Version: 3.9.6
+Standards-Version: 4.5.0
 Homepage: http://hime-ime.github.io
-Build-Depends: debhelper (>= 9.20151219),
-               autotools-dev,
+Build-Depends: debhelper-compat (= 13),
                dpkg-dev (>= 1.16.1~),
                libanthy-dev,
                libappindicator-dev,
                libchewing3-dev,
                libgtk2.0-dev (>= 2.20.0),
                libgtk-3-dev,
-               libqt4-dev,
                libxtst-dev,
                qtbase5-private-dev,
                qtchooser,
-Vcs-Git: git://anonscm.debian.org/pkg-ime/hime.git -b debian.sid
-Vcs-Browser: http://anonscm.debian.org/cgit/pkg-ime/hime.git/?h=debian/sid
+Rules-Requires-Root: no
+Vcs-Git: https://salsa.debian.org/debian/hime.git
+Vcs-Browser: https://salsa.debian.org/debian/hime
 
 Package: hime
 Architecture: any
@@ -30,7 +29,7 @@
          hime-data,
          hime-tables,
          libhime,
-Recommends: im-config | im-switch,
+Recommends: im-config,
             hime-gtk2-immodule,
             hime-gtk3-immodule,
 Suggests: hime-anthy,
@@ -47,7 +46,6 @@
  .
   * hime-gtk2-immodule for GTK2
   * hime-gtk3-immodule for GTK3
-  * hime-qt4-immodule for Qt4
   * hime-qt5-immodule for Qt5
 
 Package: hime-data
@@ -107,18 +105,6 @@
  .
  This package is the GTK3 input method module (immodule) for HIME.
 
-Package: hime-qt4-immodule
-Architecture: any
-Multi-Arch: same
-Depends: ${misc:Depends},
-         ${shlibs:Depends},
-         hime (>= ${source:Version}),
-Description: Qt4 input method module with HIME as backend
- HIME Input Method Editor is a input method platform, which is forked
- from the famous gcin input method.
- .
- This package is the Qt4 input method module (immodule) for HIME.
-
 Package: hime-qt5-immodule
 Architecture: any
 Multi-Arch: same

## hime 0.9.11%2Bdfsg

=== distro/dev-tools/qt5-test/Makefile ===
include ../../../config.mak

ECHO = $(shell whereis -b echo | awk '{print $$2}')

.PHONY: all
all: ed5.cpp ed5.h ed5.pro ed5a.cpp
	@ $(ECHO) -e "\x1b[1;33m** Compiling ed5...\x1b[0m"
	@ $(QT5_QMAKE_PATH) ed5.pro -o ed5.makefile && $(MAKE) -f ed5.makefile

.PHONY: clean
clean:
	-@ for FileName in ed5.makefile ed5a.o ed5.o ed5; \
	do \
		if [ -f "$$FileName" ]; then \
			$(ECHO) -e "\x1b[1;31m** "deleting $$FileName..."\x1b[0m"; \
			rm "$$FileName" ; \
		fi; \
	done
